#ifndef HEADER_H_
#define HEADER_H_

#include"StdPijo.h"
#include <ctime>
#include <cstdlib>
#include <unistd.h>
#include <iostream>
#include <sstream>
#include <fstream>
#include <string>
using namespace STDP;

const int kALTO=24;
const int kANCHO=40;
const int kLog=4;
const int kPerf=100;
const int kRank=100;

class Nave
{
private:
	int Xcoord;
	int Ycoord;
	int identidad;
public:
	Nave();
	int getX() { return(Xcoord); };
	int getY() { return(Ycoord); };
	void set0() { Xcoord = 19; Ycoord = 22; };
	void imprimir();
	void imprimirrastro();
	void mover();
};

class Jugador
{
private:
	string nombre;
	int puntuacion;
	int facil;
	int normal;
	int dificil;
	int muydificil;
	bool dnormal;
	bool ddificil;
	bool dmuydificil;
public:
	Jugador();
	string getNombre() { return nombre; };
	int getPuntuacion() { return puntuacion; };
	int getFacil() { return facil; };
	int getNormal() { return normal; };
	int getDificil() { return dificil; };
	int getMuydificil() { return muydificil; };
	bool getDesbNormal() { return dnormal; };
	bool getDesbDificil() { return ddificil; };
	bool getDesbMDificil() { return dmuydificil; };
	void setNombre(string nombre) { this->nombre = nombre; };
	void setPuntuacion(int puntuacion) { this->puntuacion = puntuacion; };
	void setFacil(int facil) { this->facil = facil; };
	void setNormal(int normal) { this->normal = normal; };
	void setDificil(int dificil) { this->dificil = dificil; };
	void setMuydificil(int muydificil) { this->muydificil = muydificil; };
	void setDesbNormal(bool conf) { this->dnormal = conf; };
	void setDesbDificil(bool conf) { this->ddificil = conf; };
	void setDesbMDificil(bool conf) { this->dmuydificil = conf; };
	void print(int x, int y);
};

class Mapa
{
private:
	Nave nave;
	bool mapa[kANCHO][kALTO];
	static const int Dificultades[4];
	int dif;
	int puntuacion;
public:
	Mapa();
	void copianave(Nave nave) { this->nave = nave; }
	void ponerminas();
	void pintarmapa();
	int getDif() { return dif; };
	int getPuntuacion() { return puntuacion; };
	int detectar();
	bool explota();
	void pintarminas();
	bool win();
	void Juego(Nave nave);
	void setDif(int dif) { this->dif = dif; }
	void Desbloquear(Jugador &player);
};

class Sistema
{
private:
	Jugador Perfiles[kPerf];
	Jugador Ranking[kRank];
	int nP;
	int nR;
public:
	Sistema() { nP = 0; nR = 0; };
	int getnP() { return nP; };
	int getnR() { return nR; };
	Jugador getPerfil(int n) { return Perfiles[n]; };
	Jugador getRank(int n) { return Ranking[n]; };
	void cargarPerfiles();
	void cargarRanking(int dif);
	void borrarPerfil(int num);
	void guardarPerfiles();
	void guardarRanking(int dif);
	void insertarPerfil(Jugador nperfil) { Perfiles[nP]=nperfil; nP++; }
	void insertarRank(Jugador nrank);
	int sacaRank(Jugador player);
};

class Menu
{
public:
	Menu() {};
	static int Mover(int posicion, int tope, bool posible);
	static void Inicio();
	static int Principal();
	static void Perfil(Jugador player);
	static void Ranking(Sistema system, int dif);
	static bool ConfirmacionPr();
	static bool GameOver();
	static void Win(int puntuacion);
	static int Dificultad(Jugador player);
};

#endif
